#include <bits/stdc++.h>
#define int long long
using namespace std;
const int k = 2;
signed main()
{
    int t;
    cin >> t;
    string sol[t];
    for(int m = 0; m < t; m++){
    int n;
    short pp[k]  , pn[k], np[k], nn[k]; // parnost, pozitivnost
    for(int i = 0; i < k; i++)
    {
        pp[i] = 0;
        pn[i] = 0;
        np[i] = 0;
        nn[i] = 0;
    }
    cin >> n;
    int a[n], b[n];

    for(int i = 0; i <n; i++)
    {

        cin >> a[i];
        if(a[i] > 0 && i %2 == 0){
            pp[a[i]]++;
        }
        else if( a[i] > 0 && i %2 == 1)
        {

            np[a[i]]++;
        }
        else if( a[i] <0 &&  i % 2 == 0)
        {

            pn[abs(a[i])]++;
        }
        else if( a[i] < 0 && i %2 == 1){
            nn[abs(a[i])]++;

        }


    }
    for(int i = 0; i <n; i++)
    {
        cin >> b[i];
        if(b[i] > 0 && i %2 == 0){
            pp[b[i]]++;
        }
        else if( b[i] > 0 && i %2 == 1)
        {

            np[b[i]]++;
        }
        else if( b[i] <0 &&  i % 2 == 0)
        {

            pn[abs(b[i])]++;
        }
        else if(b[i] <0 && i %2 == 1){

            nn[abs(b[i])]++;
        }

    }

    for(int i = 0; i <n; i++)
        {
            int q = abs(b[i]);
            if(nn[q] + pp[q] != np[q] + pn[q])
            {

                cout << pp[q] << " " << nn[q] << " " << pn[q] << np[q] << endl;
                sol[m] = "NE";
                break;
            }
            sol[m] = "DA";
        }

    }
    for(int i = 0 ; i < t;i++)
    {
        cout << sol[i] << endl;
    }
    return 0;
}